-- Title     :  Generates LitSphere materials and places it in to the library.
--
-- Copyright : 2015 veda3d.com, All rights reserved
-- Author    : Royal Ghost
-- Version   : 1.0.0 - Initial release for MAX 2012-2016.
--
-- Homepage  : http://veda3d.com
---------------------------------------------------------------------------------------------
--             MODIFY THIS AT YOUR OWN RISK
(
fn walkDir dir pattern =
(
files_arry = #()
    dirArr = GetDirectories (dir + "\\*")
 
    for d in dirArr do
    (
        join dirArr (getDirectories (d + "\\*"))
    )
 
    append dirArr (dir + "\\") -- Need to include the original top level directory
 
    for f in dirArr do
    (
        join files_arry (getFiles (f + pattern))
    )
files_arry 
)
	
fn makeLitsphereMat fxFile imgFile = 
(
grayBallMat = Environment_Probe_Gray_Ball__mi texture:imgFile
mrMat = mrMaterial surface:grayBallMat
dxMat = DxMaterial effectfile:fxFile 
b = openBitmap imgFile
dxMat.litSphereMap = b
matShellName = getFilenameFile imgFile
matShell = Shell_Material bakedMaterial:mrMat  originalMaterial:dxMat renderMtlIndex:1 viewportMtlIndex:0 name:matShellName
)

gc()
imagesTypes_arry = #("jpg","tga","png")
images_arry = #()
fxFile = (getOpenFileName caption:"Choose .fx shader" types:"Shader(*.fx)|*.fx" historyCategory:"LitSphereLib")
walkDirPath = getSavePath caption:"Choose folder with litspheres images"
LitsphereMats_arry =#()

if walkDirPath != undefined then 
(
	for i = 1 to imagesTypes_arry.count do
	(
	imgs = walkDir walkDirPath  ("*."+imagesTypes_arry[i])
		
		for f = 1 to imgs.count do
		(
		append images_arry imgs[f] 
		)
	)
)
if fxFile != undefined and images_arry.count > 0 then
(
	libFile = (getFilenamePath fxFile)+(getFilenameFile fxFile)+".mat"
	mtlLibtmp = materialLibrary()
	progressStart "Creating Litsphere materials..."	
		for i = 1 to images_arry.count do
		(
			append mtlLibtmp (makeLitsphereMat fxFile images_arry[i])
			progressUpdate (i*100/images_arry.count)
		)
	progressEnd()
		
	if (getfiles libFile).count != 0 then 
	(
		if queryBox ("Overwrite "+ libFile + " file?") title:"LitSphereLib"== true then
		(
		saveTempMaterialLibrary mtlLibtmp libFile 
		messagebox ("MatLibrary saved to :"+  libFile ) title:"LitSphereLib"
		)
	)
	else
	(
	saveTempMaterialLibrary mtlLibtmp libFile 
	messagebox ("MatLibrary saved to :"+  libFile ) title:"LitSphereLib"
	)
)
)